package net.lonestranger.game.object;

import java.awt.Color;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;

import net.lonestranger.common.ImagesLoader;
import net.lonestranger.common.Sprite;

public class PopupText extends Sprite {

	int timer;

	Font font;
	String additionalText;
	
	public PopupText(int x, int y, int w, int h, ImagesLoader imsLd, String name) {
		super(x, y, w, h, imsLd, name);

		font = new Font("Courier New", Font.BOLD, 32);

		
		setStep(0,0);
		
		timer = 0;
	
	}
	
	public int Update()
	{
		if (timer > 0)
		{
			timer--;
		
			if (timer <= 0)
			{
				return 0;
			}
			
		}
		
		return -1;
		
		
	}
	
	
	public void draw(Graphics g)
	{
		if ((timer > 0) || (timer == -1))
		{
			this.locx = (this.getPWidth() / 2) - (this.getWidth() / 2);
			this.locy = (this.getPHeight() / 2) - (this.getHeight() / 2);
		
			this.dx = 0;
			this.dy = 0;
			//System.out.println("draw " + this.getMyRectangle());
			this.drawSprite(g);
					
			System.out.println("additional text: " + additionalText);
			
			Font oldFont = g.getFont();
			g.setFont(font);
			g.setColor(Color.red);
			try{
				FontMetrics fm = g.getFontMetrics(font);
				g.drawString(additionalText, (this.getPWidth() / 2) - (fm.stringWidth(additionalText) / 2), this.locy + this.getHeight() + 100);
				g.setFont(oldFont);
			}
			catch (Exception e)
			{
				System.out.println(e.getStackTrace());
			}
			
		}
		
	}
	
	public void setTimer(int t)
	{
		this.timer = t;
	}

	public void setAdditionalText(String text) {
		// TODO Auto-generated method stub
		this.additionalText = text;
	}
	
}
