package net.lonestranger.game.object;

import java.awt.Color;
import java.awt.Graphics;

import net.lonestranger.common.ImagesLoader;
import net.lonestranger.common.Sprite;

public class Wall extends Sprite {

	private double speed = .25; // pix per sec; 
	
	private double precise_locx = 0;
	private double precise_locy = 0;
	
	
	public Wall(int x, int y, int w, int h, ImagesLoader imsLd, String name) {
		super(x, y, w, h, imsLd, name);
	
		this.setPosition(0 - this.getWidth(), 0);
		precise_locx = this.locx;
		precise_locy = this.locy;
		
		this.setStep((int)speed, 0);
		
	}

	public void update()
	{		
		this.updateSprite();
	
	    if (isActive()) {
	    	double old_plocx = precise_locx;
	    	
	        precise_locx += ((double)speed)/30.0;
	        precise_locy += dy;
	        
	        //System.out.println("plocx" + precise_locx + "   (" + (precise_locx - old_plocx) + ")");
	        
	        locx = (int)precise_locx;
//	        if (isLooping)
//	          player.updateTick();  // update the player
	      }
	}
	
	public void draw(Graphics g)
	{
	    /*
	    g.setColor(Color.red);
		g.drawRect(this.locx - this.getWidth(), this.locy, this.getWidth(), this.getHeight());
	     */	
	//	g.drawString("(" + this.locx + "," + this.locy + ") [" + this.getWidth() + "," + this.getHeight() + "]", 10, this.getPHeight() - 100);
	//	g.drawString("(" + this.precise_locx + "," + this.precise_locy + ")", 10, this.getPHeight() - 80);

		
		
		
		this.drawSprite(g);
		
		
	}

	public void speedChange(double d) {
		
		speed += d;
		
		if (speed > 30)
			speed = 30;
		else if (speed < .25)
			speed = .25;
		
		
	}

	public void setSpeed(double d) {
		this.speed = d;
	}
	
	
	
	
}
